<?php
header('Content-Type: text/html');
// file       : start_streetosm.php
// version    : 0.01 20111108
// history    : 
//              0.01 first version
// author     : Georg Verweyen
//              georg (at) familieverweyen.de
//              www.familieverweyen.de
// license    : CC BY-SA see http://creativecommons.org/licenses/by-sa/3.0/legalcode
// description: upload the data file and the picture and 
//              gets all other parameter for the script
//              streetosm.php
//
//              the routine needs a sub directory ./tmp
//              with write access
//
//
$MAX_OSM_SIZE= 6*1024*1024; // to decrease the maximum possible file size
$contactmail  = 'streetosm@familieverweyen.de';
$contactserver= 'http://www.familieverweyen.de';
//
// language configuration  // separated file ?
$txt[0]['de']='Datendatei:'; 
$txt[0]['en']='data file:'; 
$txt[1]['de']='Bilddatei:'; 
$txt[1]['en']='picture file:';
$txt[2]['de']='Starte das Skript!'; 
$txt[2]['en']='Run the script';
$txt[3]['de']='Ausgabeform:'; 
$txt[3]['en']='output form:';
$txt[4]['de']='Pr&uuml;fung'; 
$txt[4]['en']='proof';
$txt[5]['de']='Karte'; 
$txt[5]['en']='map';
$txt[6]['de']='Ausgabe:'; 
$txt[6]['en']='output:';
$txt[7]['de']='Text'; 
$txt[7]['en']='text';
$txt[8]['de']='HTML'; 
$txt[8]['en']='html';
$txt[9]['de']='Anzahl der Unterteilung auf der X-Achse (f&uuml;r die Karte)'; 
$txt[9]['en']='number of pitch on the x-axis (for map)';
$txt[10]['de']='alle Eingaben l&ouml;schen'; 
$txt[10]['en']='Delete all entries';
$txt[11]['de']='Ein Parameter ist fehlerhaft!'; 
$txt[11]['en']='A parameter is incorrect!';
$txt[12]['de']='Der Datenfile wurde nicht angegeben!'; 
$txt[12]['en']='The data file is missing!';
$txt[13]['de']='Das Bild wurde nicht angegeben!'; 
$txt[13]['en']='The picture file is mssing!';
$txt[14]['de']='Die Datendatei ist zu gro&szlig;!'; 
$txt[14]['en']='The data file ist too big!';
$txt[15]['de']='Fehler beim Verschieben des hochgeladenen Datei! Bitte prüfen Sie die Schreibberechtigung des Verzeichnis ./tmp !'; 
$txt[15]['en']='Error moving the uploading file! Please check the write permission of directory ./tmp !';
$txt[16]['de']='Es ist ein Fehler aufgetreten:'; 
$txt[16]['en']='An error occured:';
$txt[17]['de']='Das Ergebnis des Skriptes finden Sie hier:'; 
$txt[17]['en']='The result of the script can be found here:';
$txt[18]['de']='Sollten Sie Zweifel am Ergebnis haben, können Sie das dem Autor des Scriptes mitteilen.'; 
$txt[18]['en']='If you have doubt about the outcome, you can inform the author of the script.';
$txt[19]['de']='Zu der Homepage'; 
$txt[19]['en']='Link to homepage';
$txt[20]['de']='Nachricht an den Autor'; 
$txt[20]['en']='E-mail to the author: ';
$txt[21]['de']='Skript nochmal verwenden.'; 
$txt[21]['en']='Reuse script.';
 

// Maximum size of uploaded files
$filesize=0;
if(flgUpload()) {
  $filesize=getMaxFileSize();
  if ($filesize>$MAX_OSM_SIZE) {
    $filesize=$MAX_OSM_SIZE;
  }
}
$language     =get_parameter('language','de');
list($x)      =sscanf(get_parameter('x','0'),'%d');
$work         =get_parameter('work','input');
$submit       =get_parameter('submit','');
$worktyp      =get_parameter('worktyp','');
list($part_x) =sscanf(get_parameter('part_x','0'),'%d');
$output       =get_parameter('output','');
$filename_osm =get_filename('fileosm');
$filename_pict=get_filename('filepict');

if ($submit != "") {
  $work="run";
  // Check, if the command parameter is valid ..
  $error  ='';
  switch ($worktyp) {
    case 'check': {
      if (strlen($filename_osm)==0) {
        $work ='error';
        $error=$txt[12][$language];
        break;
      }
      if (($_FILES['fileosm']['error']>0) | ($_FILES['fileosm']['size'] > $filesize)) {
        $work ='error';
        if ($language=='de') {
          $info_size=number_format($filesize/1024, 0, ",", ".");
        } else {
          $info_size=number_format($filesize/1024, 0, ".", ",");
        }
        $error=$txt[14][$language].' ['.$info_size.' kb]';
        break;
      }
      break;    
    }
    case 'map': {
      if (strlen($filename_osm)==0) {
        $work ='error';
        $error=$txt[12][$language];
        break;
      }
      if (strlen($filename_pict)==0) {
        $work ='error';
        $error=$txt[13][$language];
        break;
      }
      if (($_FILES['fileosm']['error']>0) | ($_FILES['fileosm']['size'] > $filesize)) {
        $work ='error';
        if ($language=='de') {
          $info_size=number_format($filesize/1024, 0, ",", ".");
        } else {
          $info_size=number_format($filesize/1024, 0, ".", ",");
        }
        $error=$txt[14][$language].' ['.$info_size.' kb]';
        break;
      }
      break;    
    }
    default : {
      $work ='error';
      $error=$txt[11][$language].": $worktyp";
      break;    
    }
  }
}
//
if ($x>0) {
  if ($x>20) { // value is depend from the size of grafik!
    $language='en';
  } else {
    $language='de';
  }
}
?>
<html>
<head>
<link rel="stylesheet" type="text/css" href="streetosm.css">
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
</head>
<body>
<?php
if ($work=='error') {
  echo '<p class="error">'.$error.'</p><hr />'."\n";
  $work='input';
}
if ($work=='input') {
  //
  // display the start information
  //
  if ($language=='de') {
    // language=de
    echo '<p>';
    echo "W&auml;hlen Sie auf openstreetmap.org den gew&uuml;nschten Bereich aus und wechseln Sie auf den Reiter Export.<br />";
    echo "Speichern Sie die OpenStreetMap-XML-Daten ab.<br />";
    //echo "Speichern Sie als erstes die OpenStreetMap-XML-Daten und dann das Mapnik-Bild f&uuml;r den gleichen Bereich ab.<br />";
    echo "In dem Feld des Formulars geben Sie den Namen f&uuml;r die Datei an.<br />";
    //echo "In den Felder in dem Formular geben Sie die Namen f&uuml;r die beiden Dateien an.<br />";
    echo '</p>';
    echo '<p class="note">';
    $info_size=number_format($filesize/1024, 0, ",", ".");
    echo '<b>Hinweis:</b> Die Datei darf maximal '.$info_size.' Kb gro&szlig sein!';
    //echo "<br />Bitte wechseln Sie die Sprache bevor Sie die Dateien ausw&auml;hlen, da sonst Ihre Angaben verloren gehen!<br />";
    echo "<br />Bitte wechseln Sie die Sprache bevor Sie die Datei ausw&auml;hlen, da sonst Ihre Angaben verloren gehen!<br />";
    //echo "<br />Choose your language before you specify the files, otherwise your data will be lost!<br />";
    echo "<br />Choose your language before you specify the file, otherwise your data will be lost!<br />";
    echo '</p>';
  } else {
    // language=en
    echo '<p>';
    echo "Select the desired area on openstreetmap.org and switch to the tab export.<br />";
    echo "Save the aera as OpenStreetMap XML data.<br />";
    //echo "Save it as the first OpenStreetMap XML data and then the Mapnik-image for the same scope.<br />";
    echo "In the field on the form, specify the name for the file.<br />";
    //echo "In the fields on the form, specify the names for the two files.<br />";
    echo '</p>';
    echo '<p class="note">';
    $info_size=number_format($filesize/1024, 0, ".", ",");
    echo '<b>Note:</b> The maximum file size is '.$info_size.' Kb!';
    //echo "<br />Choose your language before you specify the files, otherwise your data will be lost!<br />";
    echo "<br />Choose your language before you specify the file, otherwise your data will be lost!<br />";
    //echo "<br />Bitte wechseln Sie die Sprache bevor Sie die Dateien ausw&auml;hlen, da sonst Ihre Angaben verloren gehen!<br />";
    echo "<br />Bitte wechseln Sie die Sprache bevor Sie die Datei ausw&auml;hlen, da sonst Ihre Angaben verloren gehen!<br />";
    echo '</p>';
  }
?>
  <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data">
    <input type="hidden" name="work" value="input">
    <input type="hidden" name="language" value="<?php echo $language; ?>" >
    <table class="layout">
      <tr><td width="120px">&nbsp;</td><td align="right"><input type="image" src="language.gif" alt="language / Sprachen"></td></tr>
      <tr><td><?php echo $txt[0][$language]; ?></td><td><input type="file" name="fileosm" size="45" value=""></td></tr>  
      <!--
      <tr><td><?php echo $txt[1][$language]; ?></td> <td><input type="file" name="filepict" size="45" value=""></td></tr>
      -->
      <tr><td><?php echo $txt[3][$language]; ?></td> 
          <td><input type="radio" name="worktyp" value="check" checked="checked"><?php echo $txt[4][$language]; ?>
              <!--
              <input type="radio" name="worktyp" value="map"><?php echo $txt[5][$language]; ?>
              <select name="part_x" size="1"><option>3</option><option>4</option>
                <option selected="selected">5</option><option>6</option>
                <option>7</option><option>8</option><option>9</option>
              </select>
              <?php echo $txt[9][$language]; ?>
              -->
          </td></tr>
      <tr><td><?php echo $txt[6][$language]; ?></td> 
          <td><input type="radio" name="output" value="text"><?php echo $txt[7][$language]; ?>
              <input type="radio" name="output" value="html" checked="checked"><?php echo $txt[8][$language]; ?>
          </td></tr>
      <tr><td>&nbsp;</td>
          <td align="right" id='id-button'>
            <input type="reset" name="reset" value="<?php echo $txt[10][$language]; ?>">
            <input type="submit" name="submit" value="<?php echo $txt[2][$language]; ?>">
          </td></tr>
    </table>
  </form>
<?php
} else {
  $data     = "map_".date("YmdHis");
  $source   = './tmp/'.$data.'.osm';
  $data_tmp = $_FILES['fileosm']['tmp_name'];
  if (!move_uploaded_file($data_tmp, $source)) {
    echo '<p class="error">'.$txt[15][$language].'<br /></p>';
    die();
  }
  $post_data = array(
    'file' => $source,
    'output' => $output,
    'work' => $worktyp
  );
  // Send a request to example.com 
  $serverpath='http://'.$_SERVER['HTTP_HOST'].substr($_SERVER['REQUEST_URI'],
              0,strlen($_SERVER['REQUEST_URI'])-strlen('start_streetosm.php'));
  $result = post_request($serverpath.'/streetosm.php', $post_data);
 
  if ($result['status'] == 'ok') {
    // print the result of the whole request:
    $filename='./tmp/'.$data.'.php';
    $handleout=fopen($filename,'w');
    fputs($handleout,$result['content']);
    fclose($handleout);
    echo $txt[17][$language];
    echo ' <a href="./tmp/'.$data.'.htm" target="_blank">'.$data.'</a><br /><br />'."\n";
    echo $txt[18][$language].'<br />';
    echo '<a href="mailto:'.$contactmail.'?subject=StreetOSM: '.$data.'">'.$txt[20][$language].'</a>&nbsp;';
    echo '<a href="'.$contactserver.'">'.$txt[19][$language].'</a>&nbsp;';
    echo '<a href="'.$_SERVER['PHP_SELF'].'">'.$txt[21][$language].'</a>';
  } else {
    echo '<p class="error">' .$txt[16][$language].'<br/ >'.$result['error'].'</p>'; 
  }
  // End of request
}
?>
</body>
</html>
<?php
function get_parameter ($parameter, $default) {
  // get parameter value (checks the parameter in the order 
  // of $_POST and $_GET. The default value is set when 
  // there is no value
  $returnvalue='';
  if (isset($_POST[$parameter])) {
    $returnvalue=$_POST[$parameter];
  } elseif (isset($_GET[$parameter])) {
    $returnvalue=$_GET[$parameter];
  }
  if ($default!='') {
    if ($returnvalue == '') {
      $returnvalue=$default;
    }
  }
  return $returnvalue;
}

function get_filename ($parameter) {
  // get filename value 
  $returnvalue='';
  if (isset($_FILES[$parameter])) {
    $returnvalue=$_FILES[$parameter]['name'];
  } 
  return $returnvalue;
}

function calcPHPUnit($size){
  $value['MB'] = 1048576;
  $value['Mb'] = 1048576;
  $value['M'] = 1048576;
  $value['m'] = 1048576;
  $value['KB'] = 1024;
  $value['Kb'] = 1024;
  $value['K'] = 1024;
  $value['k'] = 1024;
  while(list($key) = each($value)){
    if ((strlen($size) > strlen($key)) && 
        (substr($size, strlen($size)-strlen($key)) == $key)) {
      $size = substr($size, 0, strlen($size)-strlen($key))*$value[$key];
      break;
    }
  }
  return $size;
}

function flgUpload() {
  $flg = TRUE;
  if (strtolower(@ini_get('file_uploads'))=='off' || @ini_get('file_uploads')==0) {
    $flg=FALSE;
  }
  return $flg;
}

function getMaxFileSize() {
  $retSize = 0;
  if ($filesize = @ini_get('upload_max_filesize')) {
    $retSize = calcPHPUnit($filesize);
  }
  if ($postsize = @ini_get('post_max_size')) {
    $postsize = calcPHPUnit($postsize);
    if ($postsize < $retSize) {
      $retSize = $postsize;
    }
  }
  return $retSize;
}

function post_request($url, $data, $referer='') {
  // Convert the data array into URL Parameters like a=b&foo=bar etc.
  $data = http_build_query($data);
  // parse the given URL
  $url = parse_url($url);
  if ($url['scheme'] != 'http') { 
    die('Error: Only HTTP request are supported !');
  }
  // extract host and path:
  $host = $url['host'];
  $path = $url['path'];
  // open a socket connection on port 80 - timeout: 30 sec
  $fp = fsockopen($host, 80, $errno, $errstr, 30);
  if ($fp) { 
    // send the request headers:
    fputs($fp, "POST $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    if ($referer != '') {
      fputs($fp, "Referer: $referer\r\n");
    }
    fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
    fputs($fp, "Content-length: ". strlen($data) ."\r\n");
    fputs($fp, "Connection: close\r\n\r\n");
    fputs($fp, $data);
    //
    $result = ''; 
    while(!feof($fp)) {
      // receive the results of the request
      $result .= fgets($fp, 128);
    }
  } else { 
    return array(
      'status' => 'err', 
      'error' => "$errstr ($errno)"
    );
  }
  // close the socket connection:
  fclose($fp);
  // split the result header from the content
  $result = explode("\r\n\r\n", $result, 2);
  $header  = isset($result[0]) ? $result[0] : '';
  $content = isset($result[1]) ? $result[1] : '';
  // if searchstring doesn't exist in the header, skip header and footer info
  $headerinfo=explode(' ',$header);
  $flag=true;
  $seachstring='Content-Length:';
  $seachlength=strlen(searchstring);
  for ($i;$i<count($headerinfo);$i++) {
    if (strncmp($headerinfo[$i],$searchstring,$searchlength)==0) {
      $flag=false;
      break;
    }
  }
  if (flag) {
    if (strpos($content,chr(13))>0) {
      $content=substr($content,strpos($content,chr(13))+1);
    }
    if (strrpos($content,chr(13))>0) {
      $content=substr($content,0,strrpos($content,chr(13))-1);
    }
    if (strrpos($content,chr(13))>0) {
      $content=substr($content,0,strrpos($content,chr(13))-1);
    }
  }
  // return as structured array:
  return array(
    'status'  => 'ok',
    'header'  => $header,
    'content' => $content
  );
}
?>
